### Navigation

- index
- modules |
- next |
- previous |
- Python v3.0.1 documentation »
- The Python Standard Library »

# Numeric and Mathematical Modules

The modules described in this chapter provide numeric and math-related functions and data types. The `numbers` module defines an abstract hierarchy of numeric types. The `math` and `cmath` modules contain various mathematical functions for floating-point and complex numbers. For users more interested in decimal accuracy than in speed, the `decimal` module supports exact representations of decimal numbers.

The following modules are documented in this chapter:

- `numbers` — Numeric abstract base classes
  - The numeric tower
  - Notes for type implementors
    - Adding More Numeric ABCs
    - Implementing the arithmetic operations
- `math` — Mathematical functions
  - Number-theoretic and representation functions
  - Power and logarithmic functions
  - Trigonometric functions
  - Angular conversion
  - Hyperbolic functions
- Constants
- `cmath` — Mathematical functions for complex numbers
  - Complex coordinates
  - cmath functions
- `decimal` — Decimal fixed point and floating point arithmetic
  - Quick-start Tutorial
  - Decimal objects
    - Logical operands
  - Context objects
  - Signals
  - Floating Point Notes
    - Mitigating round-off error with increased precision
    - Special values
  - Working with threads
  - Recipes
  - Decimal FAQ
- `fractions` — Rational numbers
- `random` — Generate pseudo-random numbers
- `itertools` — Functions creating iterators for efficient looping
  - Itertool functions
  - Examples
  - Recipes
- `functools` — Higher order functions and operations on callable objects
  - `partial` Objects
- `operator` — Standard operators as functions
  - Mapping Operators to Functions

### Navigation

- index
- modules |
- next |
- previous |
- Python v3.0.1 documentation »
- The Python Standard Library »